<?php

function md_manager_product($form, &$form_sate) {
  $purchase_code = variable_get('md_purchase_code', array());
  $form['product_list'] = array(
    '#markup' => theme('product_list', array('purchase_code' => $purchase_code))
  );

  $form['purchase_code'] = array(
    '#type' => 'textfield',
    '#title' => t('Purchase Code'),
    '#required' => TRUE,
    '#description' => t('Enter old purchase code to delete, new purchase code to add.'),
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Add Purchase Code'),
  );

  return $form;
}

function md_manager_product_validate($form, &$form_sate){
  global $base_url;
  $purchase_code = $form_sate['values']['purchase_code'];
  $purchase_code_stored = variable_get('md_purchase_code', array());
  $site_key = drupal_hmac_base64($base_url, drupal_get_private_key());
  if (!in_array($purchase_code, $purchase_code_stored)) {
    $data = array(
      'purchase_code' => $purchase_code,
      'url' => $base_url,
      'site_key' => $site_key,
    );

    $request = array(
      'headers' => array(
        'Content-Type' => 'application/x-www-form-urlencoded',
      ),
      'data' => drupal_http_build_query($data),
      'method' => 'POST',
      'timeout' => 10,
    );

    $url = 'http://megadrupal.com/api/v1/validate/';
    $request = drupal_http_request($url, $request);
    if ($request->code == '200') {
      $data = drupal_json_decode($request->data);
      if ($data['status'] != 2) {
        form_set_error('purchase_code', t($data['message']));
      }
      else {
        drupal_set_message($data['message']);
      }
    }
    else {
      form_set_error('purchase_code', t('Can\'t connect to server.'));
    }
  }
}

function md_manager_product_submit($form, &$form_sate) {
  $purchase_code = $form_sate['values']['purchase_code'];
  $purchase_code_stored = variable_get('md_purchase_code', array());
  if (in_array($purchase_code, $purchase_code_stored)) {
    foreach ($purchase_code_stored as $key => $code) {
      if ($purchase_code == $code) {
        unset($purchase_code_stored[$key]);
      }
    }
   $message = t('Purchase code was successfully removed from your website') ;
  }
  else{
    $purchase_code_stored = array_merge($purchase_code_stored, array($purchase_code));
    $message = t('Purchase code was successfully added into your website.') ;
  }
  variable_set('md_purchase_code', $purchase_code_stored);
  drupal_set_message($message, 'status');
}
